SystemOrganization addCategory: #'JQWidgetBox-CheckTree-Dev-Tests'!
SystemOrganization addCategory: #'JQWidgetBox-CheckTree-Dev-Example'!

JQWidgetBoxWidgetTest subclass: #JQCheckTreeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-CheckTree-Dev-Tests'!

!JQCheckTreeTest methodsFor: 'testing' stamp: 'tbn 9/22/2010 14:16'!
testActions

	self
		assert: ((self jQuery: 'ul.tree') checkTree expand)
		equals: self function , '("ul.tree").checkTree({"labelAction":"expand"})'.
		
	self
		assert: ((self jQuery: 'ul.tree') checkTree check)
		equals: self function , '("ul.tree").checkTree({"labelAction":"check"})'.		
		
	
! !

!JQCheckTreeTest methodsFor: 'testing' stamp: 'tbn 9/22/2010 14:17'!
testEvents

	self
		assert: ((self jQuery: 'ul.tree') checkTree onCheck: (self javascript alert: 'onCheck called'))
		equals: self function , '("ul.tree").checkTree({"onCheck":function(){alert("onCheck called")}})'.

	self
		assert: ((self jQuery: 'ul.tree') checkTree onCollapse: (self javascript alert: 'onCollapse called'))
		equals: self function , '("ul.tree").checkTree({"onCollapse":function(){alert("onCollapse called")}})'.	
			
	self
		assert: ((self jQuery: 'ul.tree') checkTree onExpand: (self javascript alert: 'onExpand called'))
		equals: self function , '("ul.tree").checkTree({"onExpand":function(){alert("onExpand called")}})'.

	self
		assert: ((self jQuery: 'ul.tree') checkTree onHalfCheck: (self javascript alert: 'onHalfCheck called'))
		equals: self function , '("ul.tree").checkTree({"onHalfCheck":function(){alert("onHalfCheck called")}})'.

	self
		assert: ((self jQuery: 'ul.tree') checkTree onLabelHoverOut: (self javascript alert: 'onLabelHoverOut called'))
		equals: self function , '("ul.tree").checkTree({"onLabelHoverOut":function(){alert("onLabelHoverOut called")}})'.
		
	self
		assert: ((self jQuery: 'ul.tree') checkTree onLabelHoverOver: (self javascript alert: 'onLabelHoverOver called'))
		equals: self function , '("ul.tree").checkTree({"onLabelHoverOver":function(){alert("onLabelHoverOver called")}})'.
		
	self
		assert: ((self jQuery: 'ul.tree') checkTree onUnCheck: (self javascript alert: 'onUnCheck called'))
		equals: self function , '("ul.tree").checkTree({"onUnCheck":function(){alert("onUnCheck called")}})'.													! !

JQWidgetExample subclass: #JQCheckTreeExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-CheckTree-Dev-Example'!

!JQCheckTreeExample classSide methodsFor: 'accessing' stamp: 'tbn 11/2/2009 18:35'!
description
	^ 'JQuery CheckTree'! !

!JQCheckTreeExample classSide methodsFor: 'accessing' stamp: 'tbn 11/2/2009 18:36'!
shortName
	^'checktree'! !

!JQCheckTreeExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 18:36'!
renderCheckTreeFor: aClass on: html

	html listItem: [
		html checkbox.			
		html label: aClass name.
		aClass subclasses isEmpty ifFalse: [
			html unorderedList: [
				aClass subclasses do: [:each | self renderCheckTreeFor: each on: html]]]]		
	! !

!JQCheckTreeExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 18:36'!
renderCheckTreeOn: html

	self renderCheckTreeFor: Collection on: html! !

!JQCheckTreeExample methodsFor: 'rendering' stamp: 'tbn 11/2/2009 18:36'!
renderContentOn: html
	|id|
	id := 'ul.tree'.
 	html unorderedList 
		class: 'tree'; 
		script: ((html jQuery id: id) checkTree expand);
		with: [self renderCheckTreeOn: html]! !

!JQCheckTreeExample methodsFor: 'updating' stamp: 'tbn 11/2/2009 18:52'!
updateRoot: html
	super updateRoot: html.					 	 
	html stylesheet url: self library / #checktreeCss.
	html javascript url: self library / #jquerychecktree03b1minJs.	! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-checktree-dev' stamp: 'tbn 11/2/2009 19:05'!
jquerychecktree03b1Js
	^ '/**
    Project: CheckTree jQuery Plugin
    Version: 0.3 (porkchop)
    Project Website: http://jquery-checktree.googlecode.com/
    Author: JJ Geewax <jj@geewax.org>
    
    License:
        The CheckTree jQuery plugin is currently available for use in all personal or 
        commercial projects under both MIT and GPL licenses. This means that you can choose 
        the license that best suits your project and use it accordingly.
*/
(function(jQuery) {
jQuery.fn.checkTree = function(settings) {
    
    settings = jQuery.extend({
        /* Callbacks
            The callbacks should be functions that take one argument. The checkbox tree
            will return the jQuery wrapped LI element of the item that was checked/expanded.
        */
        onExpand: null,
        onCollapse: null,
        onCheck: null,
        onUnCheck: null,
        onHalfCheck: null,
        onLabelHoverOver: null,
        onLabelHoverOut: null,
        
        /* Valid choices: ''expand'', ''check'' */
        labelAction: "expand",
        
        // Debug (currently does nothing)
        debug: false
    }, settings);
    
    var $tree = jQuery("ul.tree");
	var $lis = $tree.find(''li'');
	var $checkboxes = $lis.find(":checkbox");
	
	// Hide all checkbox inputs
    $checkboxes.css(''display'', ''none'');
	
	$lis.not('':has(.arrow)'').each(function() {
		// This little piece here is by far the slowest.
		jQuery(this).prepend(''<div class="arrow"></div><div class="checkbox"></div>'');
	});
	
	// Hide all sub-trees
	$tree.find(''li > ul'').css(''display'', ''none'');
	
	/*
	What to do when the arrow is clicked
	Tried:
	 - $lis.filter('':has(li)'').find('' > .arrow'')
	 - $lis.filter('':has(li)'').find(''.arrow'')
	 - $tree.find(''li:has(li) .arrow'')
	 - $tree.find(''li:has(li) > .arrow'') <- This was the fastest.
	*/
	$tree.find(''li:has(li) > .arrow'')
		.click(function() {
			var $this = jQuery(this);
			$this
				.toggleClass(''expanded'')
				.toggleClass(''collapsed'')
				.siblings("ul:first")
					.toggle()
			;
			
			// Handle callbacks
			if (settings.onExpand && $this.hasClass(''expanded'')) {
				settings.onExpand($this.parent());
			}
			else if (settings.onCollapse && $this.hasClass(''collapsed'')){
				settings.onCollapse($this.parent());
			}
		})
		.addClass(''collapsed'')
	;
	
	/*
	What to do when the checkbox is clicked
	*/
	$tree.find(''.checkbox'').click(function() {
		var $this = jQuery(this);
		$this
			.toggleClass(''checked'')
			.removeClass(''half_checked'')
			.siblings('':checkbox:first'').attr(''checked'', $this.hasClass(''checked'') ? ''checked'' : '''')
		;
		
		$this.filter(''.checked'').siblings(''ul:first'').find(''.checkbox:not(.checked)'')
			.removeClass(''half_checked'')
			.addClass(''checked'')
			.siblings('':checkbox'').attr(''checked'', ''checked'')
		;
		$this.filter('':not(.checked)'').siblings(''ul:first'').find(''.checkbox.checked'')
			.removeClass(''checked half_checked'')
			.siblings('':checkbox'').attr(''checked'', '''')
		;
		
		// Send a change event to our parent checkbox:
		$this.parents("ul:first").siblings(":checkbox:first").change();
		
		// Handle callbacks
		if (settings.onCheck && $this.hasClass(''checked'')) {
			settings.onCheck($this.parent());
		}
		else if (settings.onUnCheck && $this.hasClass(''checked'') == false) {
			settings.onUnCheck($this.parent());
		}
	});
	
	/*
	What to do when a checkbox gets a change event
	(Fired when the children of this checkbox have changed)
	*/
	$checkboxes.change(function() {
		// If all the children are checked, this should be checked:
		var $this = jQuery(this);
		var $checkbox = $this.siblings(''.checkbox:first'');
		var any_checked = $this.siblings(''ul:first'').find('':checkbox:checked:first'').length == 1;
		var any_unchecked = $this.siblings(''ul:first'').find('':checkbox:not(:checked):first'').length == 1;
		
		if (any_checked) {
			$this.attr(''checked'', ''checked'');
			if (any_unchecked) {
				$checkbox
					.addClass(''half_checked'')
					.removeClass(''checked'')
				;
				if (settings.onHalfCheck) {
					settings.onHalfCheck($this.parent());
				}
			}
			else {
				$checkbox
					.addClass(''checked'')
					.removeClass(''half_checked'')
				;
			}
		}
		else {
			$checkbox.removeClass(''checked half_checked'');
			$this.attr(''checked'', '''');
		}
	});
	
	/*
	What to do when a label is hovered or clicked
	*/
	$tree.find(''label'')
		.click(function() {
			switch(settings.labelAction) {
				case ''expand'':
					jQuery(this).siblings(''.arrow:first'').click();
					break;
				case ''check'':
					jQuery(this).siblings(''.checkbox:first'').click();
					break;
			}
		})
		
		.hover(
			function() {
				jQuery(this).addClass("hover");
				if (settings.onLabelHoverOver) {
					settings.onLabelHoverOver(jQuery(this).parent());
				}
			},
			function() {
				jQuery(this).removeClass("hover");
				if (settings.onLabelHoverOut) {
					settings.onLabelHoverOut(jQuery(this).parent());
				}
			}
		)
	;
	
	/*
	Extra convenience methods
	*/
	$tree.clear = function() {
		$tree.find(''.checkbox'')
			.removeClass(''checked'')
			.siblings('':checkbox'').attr(''checked'', '''')
		;
	};
};
})(jQuery);'! !
